function DOMtoString() {
    var imgs = document.getElementsByTagName("img");
    var videos = document.getElementsByTagName("video");
    var images = [];
    var $boxs = [];

    if (location.href.indexOf("huaban.com") > -1) {
        $boxs = jQuery(".pin");
    }
    else if (location.href.indexOf("pinterest.com") > -1) {
        $boxs = jQuery("[data-grid-item]");
    }

    for (var i = 0; i < imgs.length; i++) {
        var img = imgs[i];
        if (img.width < 5 || img.height < 5) {
            continue;
        }

        var src = img.src;
        var width = img.naturalWidth;
        var height = img.naturalHeight;
        var urlConverted = false;

        if (img.currentSrc && img.currentSrc !== img.src) {
            src = img.currentSrc;
        }

        if (src && src.indexOf("data:image") === -1) {
            if (/\S+[.]pinimg[.]com/.test(src)) {
                if (typeof img.srcset === 'string') {
                    var srcs = img.srcset.split(",");
                    var s = srcs[srcs.length - 1].replace(/[0-9]+x/g, "").trim();
                    if (/\S+[.]pinimg[.]com/.test(s)) {
                        src = s;
                        urlConverted = true;
                    }
                }
            }
        }
        
        // Huaban 补强
        var customTitle;
        if (location.href.indexOf("huaban.com") > -1) {
            var $pin = $boxs.has(img);
            if ($pin.length > 0) {
                var description = $pin.find("p.description").attr("data-formatted");
                if (description && description.length > 0) {
                    customTitle = description.trim();
                }
            }
        }
        // Pinterest 增强
        else if (location.href.indexOf("pinterest.com") > -1) {
            var $pin = $boxs.has(img);
            if ($pin.length > 0) {
                var description = $pin.find("[data-force-refresh]").text();
                if (description && description.length > 0) {
                    customTitle = description.trim();
                }
            }
        }

        var img = {
            type: "image",
            width: width,
            height: height,
            src: src,
            title: customTitle || getBestTitle(img)
        };

        if (urlConverted) {
            img.urlConverted = true;
        }
        
        images.push(img);
    }

    for (var j = 0; j < videos.length; j++) {
        var video = videos[j];
        var width = video.videoWidth;
        var height = video.videoHeight;

        if (!video.duration) continue;

        var src;
        if (video.currentSrc) {
            src = video.currentSrc
        }

        if (src.indexOf(".mp4") > -1 || src.indexOf(".MP4") > -1 || src.indexOf(".webm") > -1 || src.indexOf(".WEBM") > -1) {
            var video = {
                type: "video",
                width: width,
                height: height,
                duration: video.duration,
                src: src,
                title: getBestTitle(video)
            };
            images.push(video);   
        }
    }

    var bgs = getBackgroundImages();
    bgs.forEach(function(bg) {
        images.push(bg);
    });

    // images.sort(function(a, b) {
    //     return (b.width * b.height) - (a.width * a.height);
    // });
    return images;
}

function getStyle(x, styleProp) {
    if (x.currentStyle) var y = x.currentStyle[styleProp];
    else if (window.getComputedStyle) var y = document.defaultView.getComputedStyle(x, null).getPropertyValue(styleProp);
    return y;
}

function getBackgroundImages() {

    var elements = document.getElementsByTagName('*');
    var results = [], i = 0, bgIm;
    for (var i = 1; i < elements.length; i++) {

        bgIm = getStyle(elements[i], 'background-image');

        if (bgIm && bgIm !== 'none' && bgIm.indexOf("gradient") === -1) {

            if (bgIm && bgIm.indexOf("data:image") === -1) {
                bgIm = bgIm.replace(/url\((['"])?(.*?)\1\)/gi, '$2');
            }

            var image = new Image();
            image.src = bgIm;

            var width = image.width,
                height = image.height;

            if (width < 5 || height < 5) { continue; }

            var bgImName = "";
            try {
                if (bgIm) {
                    bgImName = decodeURIComponent(bgIm).split('/').pop().replace(/\.[^.]*$/,'');
                }
            } catch (err) {}

            results.push({
                type: "image",
                title: elements[i].alt || elements[i].title || bgImName,
                width: width,
                height: height,
                src: bgIm,
            });
        }
    }
    return results;
}

function getBestTitle (target) {
    var title = (target && (target.customTitle || target.title) ) || (target && target.alt);
    try {
        title = title && title.trim();
        var src = target.currentSrc || target.src || getLargeSrcFromSrcset(target.srcset);
        if (!title && src && src.indexOf(".") > -1) {
            try {
                title = decodeURIComponent(src).split('/').pop().replace(/\.[^.]*$/,'');
                // 避免将图床 id 作为名称
                if (title && title.match(/[^a-zA-Z0-9 -_]/g) === null) {
                    var dnum = title.split(/\d+/).length;
                    var snum = title.split(" ").length;
                    if (snum === 1 && dnum > 2) {
                        title = document.title;
                    }
                }
            }
            catch (err) {}
        }
        if (!title || title == parseInt(title)) {
            title = document.title;
        }
        return title;
    }
    catch (err) {
        return title;
    }
}

function getLargeSrcFromSrcset (srcset) {
    if (!srcset) return;
    return srcset.replace(/ [0-9]+w/g, "").replace(/ [0-9]+x/g, "").split(",").reverse()[0];
}

chrome.runtime.sendMessage({
    action: "getSource",
    source: JSON.stringify(DOMtoString())
});

