var isFirefox = navigator.userAgent.indexOf("Firefox") > -1;
var i18n = {
    'default': {
        'dropdown': {
            'save-url': 'Save URL to Eagle',
            'save-images': 'Batch save',
            'save-bookmark': 'Save as Bookmark',
            'capture-selected': 'Capture Area',
            'capture-visible': 'Capture Visible',
            'capture-entire': 'Capture Page',
            'capturing': 'Capturing page...',
            'capture-almost-done': 'Almost done...',
            'capture-entire-beta': 'Capture Entire Page (Beta)',
            'never-drag-url': 'Disable drag on this URL',
            'never-drag-domain': 'Disable drag on this Domain',
            'enable': '<span class="state-enable">Enabled</span> on this site',
            'disable': '<span class="state-disable">Disabled</span> on this site',
            'shortcuts': 'Shortcuts Settings',
            'ranking': 'Rating on Chrome Store?',
            'feedback': 'Help & Feedback',
            'new-version': 'New version update:',
        },
        'settings': {
            'title': 'Preferences',
            'back': 'Back',
            'drag-feature': 'Drag behavior',
            'drag-cursor': 'Auto-Detect',
            'drag-bottom': 'Bottom',
            'drag-disable': 'Disable',
            'format-feature': 'File Format',
            'collect-setting': 'Collect Mode',
            'using-collect': 'Categorize when collecting images',
            'screenshot-setting': 'Screenshot',
            'using-retina': 'Take 2x sized screenshot when using retina display.',
            'shortcuts': 'Shortcuts',
            'shortcuts-btn': 'Configure shortcuts',
            'shortcuts-placeholder': 'Type a shortcut',
            'shortcuts-save-url': 'Save URL',
            'shortcuts-save-images': 'Batch save',
            'shortcuts-capture-selected': 'Capture Area',
            'shortcuts-capture-visible': 'Capture Visible',
            'shortcuts-capture-entire': 'Capture Page',
            'feedback': 'Feedback',
            'feedback-content': `Please feel free to contact our support team at <a id="feedback">services@eagle.cool</a>.`,
        },
        'error': {
            'not-open-app': 'Please open Eagle app first.'
        }
    },
    'ja': {
        'dropdown': {
            'save-url': 'URL を Eagle に保存',
            'save-images': 'バッチ保存',
            'save-bookmark': 'Save as Bookmark',
            'capture-selected': 'エリアをスクショ',
            'capture-visible': 'ビジブルエリアをスクショ',
            'capture-entire': 'ページ全体をスクスクショ',
            'capturing': 'Capturing page...',
            'capture-almost-done': 'Almost done...',
            'capture-entire-beta': 'Capture Entire Page (Beta)',
            'never-drag-url': 'このURLに無効にドラッグ',
            'never-drag-domain': 'このドメイン上の無効ドラッグ',
            'enable': '<span class="state-enable">Enabled</span> on this site',
            'disable': '<span class="state-disable">Disabled</span> on this site',
            'shortcuts': 'Shortcuts Settings',
            'ranking': 'Rating on Chrome Store?',
            'feedback': 'Help & Feedback',
            'new-version': '新バージョン：',
        },
        'settings': {
            'title': '設定',
            'back': '戻る',
            'drag-feature': 'ドラッグを設定',
            'drag-cursor': 'ドラッグした方向で現る',
            'drag-bottom': 'ウインドウ底で現る',
            'drag-disable': '無効化',
            'format-feature': 'ファイルフォーマット',
            'collect-setting': '保存設定',
            'using-collect': '画像を保存する同時に編集ウインドウで分類',
            'screenshot-setting': 'スクリーンショットを設定',
            'using-retina': 'Retina ディスプレイで高解像度スクショをする',
            'shortcuts': 'スクリーンショットを設定',
            'shortcuts-btn': 'ショートカットキーを設定',
            'shortcuts-placeholder': 'ショートカットキーを入力',
            'shortcuts-save-url': 'URLを保存',
            'shortcuts-save-images': 'バッチ保存',
            'shortcuts-capture-selected': 'エリアをスクショ',
            'shortcuts-capture-visible': 'ビジブルエリアをスクショ',
            'shortcuts-capture-entire': 'ページ全体をスクスクショ',
            'feedback': 'Feedback',
            'feedback-content': `Please feel free to contact our support team at <a id="feedback">services@eagle.cool</a>.`,
        },
        'error': {
            'not-open-app': 'Please open Eagle app first.'
        }
    },
    'zh-TW': {
        'dropdown': {
            'save-url': '將網址保存至 Eagle',
            'save-images': '批次收藏',
            'save-bookmark': '收藏為書籤',
            'capture-selected': '選擇區域截圖',
            'capture-visible': '可視區域截圖',
            'capture-entire': '整張網頁截圖',
            'capturing': '正在進行截圖...',
            'capture-almost-done': '即將完成...',
            'capture-entire-beta': '整頁截圖 (Beta)',
            'never-drag-url': '在此網址禁用拖曳功能',
            'never-drag-domain': '在此網域禁用拖曳功能',
            'enable': '拖曳保存功能「<span class="state-enable">啟用</span>」',
            'disable': '拖曳保存功能「<span class="state-disable">禁用</span>」',
            'shortcuts': '快速鍵設定',
            'ranking': '給我們評分',
            'feedback': '問題與回饋',
            'new-version': '發現新版本：',
        },
        'settings': {
            'title': '設定',
            'back': '返回',
            'drag-feature': '拖曳收藏',
            'drag-cursor': '拖曳方向',
            'drag-bottom': '視窗下方',
            'drag-disable': '關閉',
            'format-feature': '截圖格式',
            'collect-setting': '收藏設定',
            'using-collect': '收藏圖片時，顯示編輯視窗進行分類',
            'screenshot-setting': '截圖設定',
            'using-retina': '如果設備支援，使用 Retina 進行截圖',
            'shortcuts': '快速鍵設定',
            'shortcuts-btn': '開啟快速鍵設定頁面',
            'shortcuts-placeholder': '輸入快速鍵',
            'shortcuts-save-url': '收藏書籤',
            'shortcuts-save-images': '批次收藏',
            'shortcuts-capture-selected': '選擇區域截圖',
            'shortcuts-capture-visible': '可視區域截圖',
            'shortcuts-capture-entire': '整張網頁截圖',
            'feedback': '意見與問題反饋',
            'feedback-content': `使用過程中有遇到任何問題，請與我們聯繫，我們的信箱是：<a id="feedback">services@eagle.cool</a>`,
        },
        'error': {
            'not-open-app': '請先開啟 Eagle 應用程式'
        }
    },
    'zh-CN': {
        'dropdown': {
            'save-url': '将网址保存至 Eagle',
            'save-images': '批量收藏',
            'save-bookmark': '收藏为书签',
            'capture-selected': '选择区域截图',
            'capture-visible': '可视区域截图',
            'capture-entire': '整页截图',
            'capturing': '正在进行截图...',
            'capture-almost-done': '即将完成...',
            'capture-entire-beta': '整页截图 (Beta)',
            'never-drag-url': '在此页面禁用拖拽功能',
            'never-drag-domain': '在此域名禁用拖拽功能',
            'enable': '拖拽保存功能「<span class="state-enable">启用</span>」',
            'disable': '拖拽保存功能「<span class="state-disable">禁用</span>」',
            'shortcuts': '快捷键设置',
            'ranking': '给我们评价',
            'feedback': '问题与回馈',
            'new-version': '发现新版本：',
        },
        'settings': {
            'title': '设置',
            'back': '返回',
            'drag-feature': '拖拽保存',
            'drag-cursor': '拖拽方向',
            'drag-bottom': '窗口底部',
            'drag-disable': '关闭',
            'format-feature': '截图格式',
            'collect-setting': '收藏设置',
            'using-collect': '保存图片时，显示编辑窗口进行分类',
            'screenshot-setting': '截图设置',
            'using-retina': '如果设备支持，使用 Retina 画质进行截图',
            'shortcuts': '快捷键设置',
            'shortcuts-btn': '打开快捷键设置页面',
            'shortcuts-placeholder': '输入快捷键',
            'shortcuts-save-url': '收藏书签',
            'shortcuts-save-images': '批量收藏',
            'shortcuts-capture-selected': '选择区域截图',
            'shortcuts-capture-visible': '可视区域截图',
            'shortcuts-capture-entire': '整张网页截图',
            'feedback': '意见与问题反馈',
            'feedback-content': `使用的过程中有遇到任何问题，请随时与我们联系，我们的邮箱是：<a id="feedback">services@eagle.cool</a>`,
        },
        'error': {
            'not-open-app': '请先开启 Eagle 应用程式'
        }
    },
};

var i18n_words = i18n['default'];
var language = window.navigator.language;
if (language === 'zh') {
    language = 'zh-CN';
}
if (i18n[language]) {
    i18n_words = i18n[language];
}
window.jQuery("body").addClass(language);
var metas = {
    metaTags: "",
    metaTitle: "",
    metaDescription: "",
    metaKeywords: ""
};

var appVersion;
var buildVersion;
var showCollectModal;

var shortcutsSettings;
initShortcuts();

function initShortcuts () {
    chrome.storage.sync.get(['shortcutsSettings'], function(result) {
        if (result.shortcutsSettings === undefined) {
            shortcutsSettings = {
                macOS: {
                    'url-save': 'Alt + 0',
                    'batch-save': 'Alt + 1',
                    'capture-area': 'Alt + 2',
                    'capture-visible': 'Alt + 3',
                    'capture-entire': 'Alt + 4',
                },
                Windows: {
                    'url-save': 'Alt + 0',
                    'batch-save': 'Alt + 1',
                    'capture-area': 'Alt + 2',
                    'capture-visible': 'Alt + 3',
                    'capture-entire': 'Alt + 4',
                }
            }
        }
        else {
            try {
                shortcutsSettings = JSON.parse(result.shortcutsSettings);
            }
            catch (err) {
                shortcutsSettings = {
                    macOS: {
                        'url-save': 'Alt + 0',
                        'batch-save': 'Alt + 1',
                        'capture-area': 'Alt + 2',
                        'capture-visible': 'Alt + 3',
                        'capture-entire': 'Alt + 4',
                    },
                    Windows: {
                        'url-save': 'Alt + 0',
                        'batch-save': 'Alt + 1',
                        'capture-area': 'Alt + 2',
                        'capture-visible': 'Alt + 3',
                        'capture-entire': 'Alt + 4',
                    }
                }
            }
        }
        var isMac = navigator.platform.toUpperCase().indexOf('MAC')>=0;
        if (isMac) {
            window.jQuery("#url-save-shortcut").val(shortcutsSettings['macOS']['url-save']);
            window.jQuery("#batch-save-shortcut").val(shortcutsSettings['macOS']['batch-save']);
            window.jQuery("#capture-area-shortcut").val(shortcutsSettings['macOS']['capture-area']);
            window.jQuery("#capture-visible-shortcut").val(shortcutsSettings['macOS']['capture-visible']);
            window.jQuery("#capture-entire-shortcut").val(shortcutsSettings['macOS']['capture-entire']);
            window.jQuery("#save-url .shortcut").text(shortcutsSettings['macOS']['url-save'].replace("Shift", "⇧").replace("Ctrl", "⌃").replace("Command", "⌘").replace("Alt", "⌥").replace(/\+/g, " "));
            window.jQuery("#save-images .shortcut").text(shortcutsSettings['macOS']['batch-save'].replace("Shift", "⇧").replace("Ctrl", "⌃").replace("Command", "⌘").replace("Alt", "⌥").replace(/\+/g, " "));
            window.jQuery("#capture-selected .shortcut").text(shortcutsSettings['macOS']['capture-area'].replace("Shift", "⇧").replace("Ctrl", "⌃").replace("Command", "⌘").replace("Alt", "⌥").replace(/\+/g, " "));
            window.jQuery("#capture-visible .shortcut").text(shortcutsSettings['macOS']['capture-visible'].replace("Shift", "⇧").replace("Ctrl", "⌃").replace("Command", "⌘").replace("Alt", "⌥").replace(/\+/g, " "));
            window.jQuery("#capture-entire .shortcut").text(shortcutsSettings['macOS']['capture-entire'].replace("Shift", "⇧").replace("Ctrl", "⌃").replace("Command", "⌘").replace("Alt", "⌥").replace(/\+/g, " "));
        }
        else {
            window.jQuery("#url-save-shortcut").val(shortcutsSettings['Windows']['url-save']);
            window.jQuery("#batch-save-shortcut").val(shortcutsSettings['Windows']['batch-save']);
            window.jQuery("#capture-area-shortcut").val(shortcutsSettings['Windows']['capture-area']);
            window.jQuery("#capture-visible-shortcut").val(shortcutsSettings['Windows']['capture-visible']);
            window.jQuery("#capture-entire-shortcut").val(shortcutsSettings['Windows']['capture-entire']);
            window.jQuery("#save-url .shortcut").text(shortcutsSettings['Windows']['url-save']);
            window.jQuery("#save-images .shortcut").text(shortcutsSettings['Windows']['batch-save']);
            window.jQuery("#capture-selected .shortcut").text(shortcutsSettings['Windows']['capture-area']);
            window.jQuery("#capture-visible .shortcut").text(shortcutsSettings['Windows']['capture-visible']);
            window.jQuery("#capture-entire .shortcut").text(shortcutsSettings['Windows']['capture-entire']);
        }
    });
}

var dragEnable = true;
var urlBlackList = [];
var domainBlackList = [];

dragMode = parseInt(localStorage.getItem("dragMode")) || 1;
chrome.storage.sync.get(['dragMode'], function(result) {
    if (result.dragMode === undefined) {
        dragMode = 1;
        dragEnable = true;
    }
    else {
        dragMode = result.dragMode;
        if (result.dragMode !== 0) {
            dragEnable = true;
        }
        else {
            dragEnable = false;
        }
    }
    window.jQuery(".drag-feature").removeClass("active");
    switch (dragMode) {
        case 0:
            window.jQuery("#drag-disable").addClass("active");
            break;
        case 1:
            window.jQuery("#drag-cursor").addClass("active");
            break;
        case 2:
            window.jQuery("#drag-bottom").addClass("active");
            break;
    }
});

var captureFormat = 'png';
captureFormat = localStorage.getItem("captureFormat") || 'png';
chrome.storage.sync.get(['captureFormat'], function(result) {
    if (result.captureFormat === undefined) {
        captureFormat = 'png';
    }
    else {
        captureFormat = result.captureFormat;
    }
    window.jQuery(".format-feature").removeClass("active");
    if (captureFormat === 'png') {
        window.jQuery("#format-png").addClass("active");
    }
    else {
        window.jQuery("#format-jpeg").addClass("active");
    }
});

document.addEventListener('DOMContentLoaded', function() {
    var tabs = chrome.tabs;
    const emojiRegex = /\uD83D\uDC69\u200D(?:\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69]))|\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08|\uD83D\uDC69\u200D(?:\uD83D\uDC69\u200D)?\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D\uDC69\u200D(?:\uD83D\uDC69\u200D)?\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC69(?:\uD83C[\uDFFB-\uDFFF])\u200D(?:\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92])|\uD83D\uDC68(?:\u200D(?:\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|(?:(?:\uD83D[\uDC68\uDC69])\u200D)?\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|(?:(?:\uD83D[\uDC68\uDC69])\u200D)?\uD83D\uDC66\u200D\uD83D\uDC66|\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83D\uDC68)|(?:\uD83C[\uDFFB-\uDFFF])\u200D(?:\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]))|(?:\uD83D\uDC69\u200D[\u2695\u2696\u2708]|\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8|\uD83D\uDC69(?:\uD83C[\uDFFB-\uDFFF])\u200D[\u2695\u2696\u2708]|\uD83D\uDC68(?:(?:\uD83C[\uDFFB-\uDFFF])\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708]))\uFE0F|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC6F\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD37-\uDD39\uDD3C-\uDD3E\uDDD6-\uDDDF])\u200D[\u2640\u2642]\uFE0F|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD37-\uDD39\uDD3D\uDD3E\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]\uFE0F|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:(?:\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|\uFE0F\u200D[\u2640\u2642])\uFE0F|(?:[\u261D\u270A-\u270D]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC70\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDCAA\uDD74\uDD7A\uDD90\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD36\uDDD1-\uDDD5])(?:\uD83C[\uDFFB-\uDFFF])|\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62(?:\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73|\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74|\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67)\uDB40\uDC7F|\uD83C\uDDFF(?:\uD83C[\uDDE6\uDDF2\uDDFC])|\uD83C\uDDFE(?:\uD83C[\uDDEA\uDDF9])|\uD83C\uDDFD\uD83C\uDDF0|\uD83C\uDDFC(?:\uD83C[\uDDEB\uDDF8])|\uD83C\uDDFB(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA])|\uD83C\uDDFA(?:\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF])|\uD83C\uDDF9(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF])|\uD83C\uDDF8(?:\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF])|\uD83C\uDDF7(?:\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC])|\uD83C\uDDF6\uD83C\uDDE6|\uD83C\uDDF5(?:\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE])|\uD83C\uDDF4\uD83C\uDDF2|\uD83C\uDDF3(?:\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF])|\uD83C\uDDF2(?:\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF])|\uD83C\uDDF1(?:\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE])|\uD83C\uDDF0(?:\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF])|\uD83C\uDDEF(?:\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5])|\uD83C\uDDEE(?:\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9])|\uD83C\uDDED(?:\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA])|\uD83C\uDDEC(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE])|\uD83C\uDDEB(?:\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7])|\uD83C\uDDEA(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA])|\uD83C\uDDE9(?:\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF])|\uD83C\uDDE8(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF])|\uD83C\uDDE7(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF])|\uD83C\uDDE6(?:\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF])|\uD83D\uDC68(?:\u200D(?:(?:(?:\uD83D[\uDC68\uDC69])\u200D)?\uD83D\uDC67|(?:(?:\uD83D[\uDC68\uDC69])\u200D)?\uD83D\uDC66)|\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC69(?:\u200D(?:(?:\uD83D\uDC69\u200D)?\uD83D\uDC67|(?:\uD83D\uDC69\u200D)?\uD83D\uDC66)|\uD83C[\uDFFB-\uDFFF])|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD37-\uDD39\uDD3D\uDD3E\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uD83C[\uDFFB-\uDFFF])|[#\*0-9]\uFE0F\u20E3|(?:[\u261D\u26F9\u270A-\u270D]|\uD83C[\uDF85\uDFC2-\uDFC4\uDFC7\uDFCA-\uDFCC]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66-\uDC69\uDC6E\uDC70-\uDC78\uDC7C\uDC81-\uDC83\uDC85-\uDC87\uDCAA\uDD74\uDD75\uDD7A\uDD90\uDD95\uDD96\uDE45-\uDE47\uDE4B-\uDE4F\uDEA3\uDEB4-\uDEB6\uDEC0\uDECC]|\uD83E[\uDD18-\uDD1C\uDD1E\uDD1F\uDD26\uDD30-\uDD39\uDD3D\uDD3E\uDDD1-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])?|(?:[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u270A\u270B\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF93\uDFA0-\uDFCA\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF4\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC3E\uDC40\uDC42-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDD7A\uDD95\uDD96\uDDA4\uDDFB-\uDE4F\uDE80-\uDEC5\uDECC\uDED0-\uDED2\uDEEB\uDEEC\uDEF4-\uDEF8]|\uD83E[\uDD10-\uDD3A\uDD3C-\uDD3E\uDD40-\uDD45\uDD47-\uDD4C\uDD50-\uDD6B\uDD80-\uDD97\uDDC0\uDDD0-\uDDE6])|(?:[#\*0-9\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23E9-\u23F3\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB-\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u261D\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u2660\u2663\u2665\u2666\u2668\u267B\u267F\u2692-\u2697\u2699\u269B\u269C\u26A0\u26A1\u26AA\u26AB\u26B0\u26B1\u26BD\u26BE\u26C4\u26C5\u26C8\u26CE\u26CF\u26D1\u26D3\u26D4\u26E9\u26EA\u26F0-\u26F5\u26F7-\u26FA\u26FD\u2702\u2705\u2708-\u270D\u270F\u2712\u2714\u2716\u271D\u2721\u2728\u2733\u2734\u2744\u2747\u274C\u274E\u2753-\u2755\u2757\u2763\u2764\u2795-\u2797\u27A1\u27B0\u27BF\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B50\u2B55\u3030\u303D\u3297\u3299]|\uD83C[\uDC04\uDCCF\uDD70\uDD71\uDD7E\uDD7F\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE02\uDE1A\uDE2F\uDE32-\uDE3A\uDE50\uDE51\uDF00-\uDF21\uDF24-\uDF93\uDF96\uDF97\uDF99-\uDF9B\uDF9E-\uDFF0\uDFF3-\uDFF5\uDFF7-\uDFFF]|\uD83D[\uDC00-\uDCFD\uDCFF-\uDD3D\uDD49-\uDD4E\uDD50-\uDD67\uDD6F\uDD70\uDD73-\uDD7A\uDD87\uDD8A-\uDD8D\uDD90\uDD95\uDD96\uDDA4\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA-\uDE4F\uDE80-\uDEC5\uDECB-\uDED2\uDEE0-\uDEE5\uDEE9\uDEEB\uDEEC\uDEF0\uDEF3-\uDEF8]|\uD83E[\uDD10-\uDD3A\uDD3C-\uDD3E\uDD40-\uDD45\uDD47-\uDD4C\uDD50-\uDD6B\uDD80-\uDD97\uDDC0\uDDD0-\uDDE6])\uFE0F/g;

    window.jQuery("#save-url .name").text(i18n_words.dropdown["save-url"]);
    window.jQuery("#save-images .name").text(i18n_words.dropdown["save-images"]);
    window.jQuery("#save-bookmark .name").text(i18n_words.dropdown["save-bookmark"]);
    window.jQuery("#capture-selected .name").text(i18n_words.dropdown["capture-selected"]);
    window.jQuery("#capture-visible .name").text(i18n_words.dropdown["capture-visible"]);
    window.jQuery("#capture-entire .name").text(i18n_words.dropdown["capture-entire"]);
    window.jQuery("#capture-entire-beta .name").text(i18n_words.dropdown["capture-entire-beta"]);
    window.jQuery("#not-open-app p").text(i18n_words.error["not-open-app"]);

    window.jQuery("#disable-drag-url .name").text(i18n_words.dropdown["never-drag-url"]);
    window.jQuery("#disable-drag-domain .name").text(i18n_words.dropdown["never-drag-domain"]);

    window.jQuery("#preferences .name").html(i18n_words.settings["title"]);
    window.jQuery("#settings-menu .settings-header .title").html(i18n_words.settings["title"]);
    window.jQuery("#settings-menu .settings-header #back").html(i18n_words.settings["back"]);
    window.jQuery("#settings-menu #drag-feature .label").html(i18n_words.settings["drag-feature"]);
    window.jQuery("#settings-menu #drag-feature #drag-cursor .name").html(i18n_words.settings["drag-cursor"]);
    window.jQuery("#settings-menu #drag-feature #drag-bottom .name").html(i18n_words.settings["drag-bottom"]);
    window.jQuery("#settings-menu #drag-feature #drag-disable .name").html(i18n_words.settings["drag-disable"]);
    window.jQuery("#settings-menu #format-feature .label").html(i18n_words.settings["format-feature"]);
    window.jQuery("#settings-menu #collect-feature .label").html(i18n_words.settings["collect-setting"]);
    window.jQuery("#settings-menu #retina-feature .label").html(i18n_words.settings["screenshot-setting"]);
    window.jQuery("#settings-menu #collect-feature label").html(i18n_words.settings["using-collect"]);
    window.jQuery("#settings-menu #retina-feature label").html(i18n_words.settings["using-retina"]);
    window.jQuery("#settings-menu #shortcuts-feature .label").html(i18n_words.settings["shortcuts"]);
    window.jQuery("#settings-menu #shortcuts-feature .btn").html(i18n_words.settings["shortcuts-btn"]);
    window.jQuery("#settings-menu #shortcuts-feature input").attr('placeholder', i18n_words.settings["shortcuts-placeholder"]);
    window.jQuery("#settings-menu #shortcuts-feature .url").html(i18n_words.settings["shortcuts-save-url"]);
    window.jQuery("#settings-menu #shortcuts-feature .batch").html(i18n_words.settings["shortcuts-save-images"]);
    window.jQuery("#settings-menu #shortcuts-feature .selected").html(i18n_words.settings["shortcuts-capture-selected"]);
    window.jQuery("#settings-menu #shortcuts-feature .visible").html(i18n_words.settings["shortcuts-capture-visible"]);
    window.jQuery("#settings-menu #shortcuts-feature .entire").html(i18n_words.settings["shortcuts-capture-entire"]);
    window.jQuery("#settings-menu #feedback-feature .label").html(i18n_words.settings["feedback"]);
    window.jQuery("#settings-menu #feedback-feature .feedback-content").html(i18n_words.settings["feedback-content"]);

    window.jQuery("#retina-support")[0].checked = localStorage.getItem("useRetina") === 'true';

    chrome.storage.sync.get(['urlBlackList', 'domainBlackList'], function(result) {
        urlBlackList = result.urlBlackList || [];
        domainBlackList = result.domainBlackList || [];
        chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
            var url = tabs[0].url;
            var domain = new URL(url).hostname;
            updateBlacklistItems(url, domain);
        });
    });

    var isMac = navigator.platform.toUpperCase().indexOf('MAC')>=0;
    if (isMac) {
        window.jQuery(".menu-item .shortcut").each(function () {
            var text = $(this).text();
            $(this).text(text.replace("Ctrl", "⌘").replace("Alt", "⌥").replace(/\+/g, " "));
        });
    }

    chrome.runtime.onMessage.addListener(function(request, sender) {
        if (request.action == "extractSiteMetas") {
            if (request.result) {
                metas = request.result;
                window.jQuery.ajax({
                    method:"GET",
                    url: "http://localhost:41595/api/application/info",
                    dataType: "json",
                    data: {},
                }).always(function (result) {
                    if (result.status !== 0) {
                        var data = result.data;
                        if (data.buildVersion) {
                            buildVersion = parseInt(data.buildVersion);
                            if (buildVersion && buildVersion >= 20200603) {
                                // 显示收藏 Youtube / Vimeo 选项
                                window.jQuery("#save-url").css("display", "block");
                                window.jQuery("#save-url-hr").css("display", "block");
                                window.jQuery("body").addClass("has-url");
                            }
                        }
                    }
                })
            }
        }
        return true;
    });

    function updateCaptureFormat (format) {
        localStorage.setItem("captureFormat", format);
        chrome.storage.sync.set({'captureFormat': format}, function() {
            console.log('设置已保存: ', format);
        });
    }

    function updateDragMode (mode) {
        chrome.tabs.query({}, function(tabs) {
            for (var i = 0; i < tabs.length; ++i) {
                chrome.tabs.sendMessage(tabs[i].id, { action: "drag-mode-" + mode }, function () {
                    if (chrome.runtime.lastError) { console.log(chrome.runtime.lastError); }
                });
            }
        });
        localStorage.setItem("dragMode", mode);
        chrome.storage.sync.set({'dragMode': mode}, function() {
            console.log('设置已保存: ', mode);
        });
    }

    function updateRetinaSupport (checked) {
        localStorage.setItem("useRetina", checked);
        chrome.runtime.sendMessage({
            action: "change-retina",
            useRetina: checked
        });
    }

    // http://localhost:41595/api/preferences/collect/on
    // http://localhost:41595/api/preferences/collect/off
    function updateCollectWindow(checked) {
        if (checked) {
            window.jQuery.ajax({
                method: "GET",
                url: "http://localhost:41595/api/preferences/collect/on",
                dataType: "json",
            }).always(function (result) {  });
        }
        else {
            window.jQuery.ajax({
                method: "GET",
                url: "http://localhost:41595/api/preferences/collect/off",
                dataType: "json",
            }).always(function (result) {  });
        }
    }

    window.jQuery("#save-images").on("click", function () {
        chrome.tabs.executeScript(null, { file: "getPagesSource.js" });
    });

    window.jQuery(".save-url-btn").on("click", function () {
        chrome.runtime.sendMessage({
            action: "save-url",
            metas: metas
        });
        setTimeout(function () { window.close(); }, 100);
    });

    window.jQuery("#url-save-shortcut").change(function () {
        if (isMac) {
            shortcutsSettings['macOS']['url-save'] = $(this).val();
        }
        else {
            shortcutsSettings['Windows']['url-save'] = $(this).val();
        }
        shortcutChange();
    });

    window.jQuery("#batch-save-shortcut").change(function () {
        if (isMac) {
            shortcutsSettings['macOS']['batch-save'] = $(this).val();
        }
        else {
            shortcutsSettings['Windows']['batch-save'] = $(this).val();
        }
        shortcutChange();
    });

    window.jQuery("#capture-area-shortcut").change(function () {
        if (isMac) {
            shortcutsSettings['macOS']['capture-area'] = $(this).val();
        }
        else {
            shortcutsSettings['Windows']['capture-area'] = $(this).val();
        }
        shortcutChange();
    });

    window.jQuery("#capture-visible-shortcut").change(function () {
        if (isMac) {
            shortcutsSettings['macOS']['capture-visible'] = $(this).val();
        }
        else {
            shortcutsSettings['Windows']['capture-visible'] = $(this).val();
        }
        shortcutChange();
    });

    window.jQuery("#capture-entire-shortcut").change(function () {
        if (isMac) {
            shortcutsSettings['macOS']['capture-entire'] = $(this).val();
        }
        else {
            shortcutsSettings['Windows']['capture-entire'] = $(this).val();
        }
        shortcutChange();
    });

    var shortcutChange = debounce(function () {
        chrome.storage.sync.set({'shortcutsSettings': JSON.stringify(shortcutsSettings)}, function() {
            chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
                chrome.tabs.sendMessage(tabs[0].id, { action: "shortcuts-change" } );
            });
        });
    }, 300, true);

    window.jQuery("body").on("keydown", ".shortcut-input", function (e) {
        e.preventDefault();

        var currentValues = $(".shortcut-input").map(function() {
            return $(this).val();
        }).get();

        var keyCode = e.keyCode;
        var char = String.fromCharCode(keyCode);
        var shiftKey = e.shiftKey;
        var metaKey = e.metaKey;
        var ctrlKey = e.ctrlKey;
        var altKey = e.altKey;
        var needCombindKey = false;
        var result = "";
        if (ctrlKey) {
            if (!isMac) {
                result += "Ctrl + ";
            }
            else {
                result += "Ctrl + ";
            }
            needCombindKey = true;
        }
        if (metaKey && isMac) { result += "Command + "; needCombindKey = true; }
        if (shiftKey) { result += "Shift + "; needCombindKey = true; }
        if (altKey) {
            if (isMac) {
                result += "Alt + ";
            }
            else {
                result += "Alt + ";
            }
            needCombindKey = true;
        }
        switch (keyCode) {
            case 8:
                // 清空快捷键
                if (result.length == 0) {
                    result = "";
                    $(this).val(result).trigger('change');
                    return;
                }
                break;
            // F1 - F12
            case 112:
                result += "F1"; needCombindKey = false; break;
            case 113:
                result += "F2"; needCombindKey = false; break;
            case 114:
                result += "F3"; needCombindKey = false; break;
            case 115:
                result += "F4"; needCombindKey = false; break;
            // case 116:
            //     result += "F5"; needCombindKey = false; break;
            case 117:
                result += "F6"; needCombindKey = false; break;
            case 118:
                result += "F7"; needCombindKey = false; break;
            case 119:
                result += "F8"; needCombindKey = false; break;
            case 120:
                result += "F9"; needCombindKey = false; break;
            case 121:
                result += "F10"; needCombindKey = false; break;
            case 122:
                result += "F11"; needCombindKey = false; break;
            case 123:
                result += "F12"; needCombindKey = false; break;
            default:
                // 英文数字按键必须要有搭配按键才算数
                if (needCombindKey) {
                    if ( ctrlKey || metaKey || altKey || shiftKey ) {
                        if (keyCode === 187) {
                            result += '=';
                            needCombindKey = false;
                        }
                        if (keyCode === 107) {
                            result += 'Plus';
                            needCombindKey = false;
                        }
                        else if (keyCode === 189 || keyCode === 109) {
                            result += '-';
                            needCombindKey = false;
                        }
                        else if (! /[^A-Za-z0-9-=+_.]/.test( char.toUpperCase() ) ) {
                            result += char.toUpperCase();
                            needCombindKey = false;
                        }
                    }
                }
        }
        if (result && !needCombindKey) {
            if (currentValues && currentValues.indexOf(result) !== -1) return;
            window.jQuery(this).val(result).trigger('change');
        }
    });

    window.jQuery("#capture-entire").on("click", function () {
        chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
            chrome.tabs.sendMessage(tabs[0].id, { action: "start-screencapture" }, function(response) {});
            setTimeout(function () { window.close(); }, 100);
        });
    });

    window.jQuery("#capture-visible").on("click", function () {
        chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
            chrome.tabs.sendMessage(tabs[0].id, { action: "start-capture-visible" }, function(response) {});
            setTimeout(function () { window.close(); }, 100);
        });
    });

    // 新版網頁截圖
    window.jQuery("#capture-entire-beta").on("click", function () {
        chrome.tabs.query({active: true, currentWindow: true}, function(tabs){
            window.jQuery.ajax({
                method:"POST",
                url: "http://localhost:41593",
                dataType: "json",
                data: {
                    type: "capture-website",
                    title: tabs[0].title.replace(/[@#$%^&*()<>:'"\/\\|?*]+/g, ''),
                    url: tabs[0].url,
                    metaTags: metas.metaTags,
                    metaTitle:  metas.metaTitle,
                    metaDescription: metas.metaDescription,
                    metaKeywords: metas.metaKeywords,
                }
            }).always(function (result) {
                if (result.status == 0) {
                    setTimeout(function () {
                        window.jQuery("#not-open-app").removeClass("hide");
                        window.jQuery("#dropdown-menu").addClass("hide");
                    }, 200);
                }
                else {
                    setTimeout(function () {
                        window.close();
                    }, 100);
                }
            })
        });
    });

    // 區域範圍選取截圖
    window.jQuery("#capture-selected").on("click", function () {
        openCropArea();
        // chrome.tabs.query({active: true, currentWindow: true}, function(tabs){
            // window.jQuery.ajax({
            //     method:"POST",
            //     url: "http://localhost:41593",
            //     dataType: "json",
            //     data: {
            //         type: "screenshot",
            //         title: tabs[0].title.replace(/[@#$%^&*()<>:'"\/\\|?*]+/g, ''),
            //         url: tabs[0].url,
            //         metaTags: metas.metaTags,
            //         metaTitle:  metas.metaTitle,
            //         metaDescription: metas.metaDescription,
            //         metaKeywords: metas.metaKeywords,
            //     }
            // }).always(function (result) {
            //     if (result.status == 0) {
            //         setTimeout(function () {
            //             window.jQuery("#not-open-app").removeClass("hide");
            //             window.jQuery("#dropdown-menu").addClass("hide");
            //         }, 200);
            //     }
            //     else {
            //         window.jQuery("body").hide().css({
            //             "height": 0,
            //             "min-height": 0
            //         });
            //         window.close();
            //     }
            // });
        // });
    });

    window.jQuery("#preferences").on("click", function () {
        window.jQuery("body").addClass("expand");
    });

    window.jQuery("#disable-drag-url").on("click", function () {
        chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
            var url = tabs[0].url;
            if (urlBlackList.indexOf(url) > -1) {
                removeFromUrlBlacklist(url);
            }
            else {
                addToUrlBlacklist(url);
            }
            updateBlacklistItems(url, undefined);
        });
    });

    window.jQuery("#disable-drag-domain").on("click", function () {
        chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
            var url = tabs[0].url;
            var domain = new URL(url).hostname;
            if (domainBlackList.indexOf(domain) > -1) {
                removeFromDomainBlacklist(domain);
            }
            else {
                addToDomainBlacklist(domain);
            }
            updateBlacklistItems(url, domain);
        });  
    });

    function updateBlacklistItems (url, domain) {
        if (url) {
            if (urlBlackList.indexOf(url) > -1) {
                window.jQuery("#disable-drag-url .checkbox").prop("checked", true);
            }
            else {
                window.jQuery("#disable-drag-url .checkbox").prop("checked", false);
            }
        }
        if (domain) {
            if (domainBlackList.indexOf(domain) > -1) {
                window.jQuery("#disable-drag-domain .checkbox").prop("checked", true);
            }
            else {
                window.jQuery("#disable-drag-domain .checkbox").prop("checked", false);
            }
        }
    }

    function brocastUpdateDragMode () {
        chrome.tabs.query({}, function(tabs) {
            for (var i = 0; i < tabs.length; ++i) {
                chrome.tabs.sendMessage(tabs[i].id, { action: "update-drag-mode" }, function(response) {
                    if (chrome.runtime.lastError) { console.log(chrome.runtime.lastError); }
                });
            }
        });
    };

    function addToUrlBlacklist (url) {
        urlBlackList.push(url);
        urlBlackList = [...new Set(urlBlackList)];
        chrome.storage.sync.set({"urlBlackList": urlBlackList}, function () {
            chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
                brocastUpdateDragMode();
            });
        })
    }

    function addToDomainBlacklist (domain) {
        domainBlackList.push(domain);
        domainBlackList = [...new Set(domainBlackList)];
        chrome.storage.sync.set({"domainBlackList": domainBlackList}, function () {
            chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
                brocastUpdateDragMode();
            });
        })
    }

    function removeFromUrlBlacklist (url) {
        var idx = urlBlackList.indexOf(url);
        if (idx > -1) {
            urlBlackList.splice(idx, 1);    
            chrome.storage.sync.set({"urlBlackList": urlBlackList}, function () {
                chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
                    brocastUpdateDragMode();
                });
            });
        }
    }

    function removeFromDomainBlacklist (domain) {
        var idx = domainBlackList.indexOf(domain);
        if (idx > -1) {
            domainBlackList.splice(idx, 1);    
            chrome.storage.sync.set({"domainBlackList": domainBlackList}, function () {
                chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
                    brocastUpdateDragMode();
                });
            });
        }
    }

    window.jQuery("#back").on("click", function () {
        window.jQuery("body").removeClass("expand");
        setTimeout(function () {
            window.jQuery("#shortcut-input").focus();
        }, 200);
    });

    window.jQuery("#drag-cursor").on("click", function () {
        window.jQuery(".drag-feature").removeClass("active");
        window.jQuery(this).addClass("active");
        updateDragMode(1);
    });

    window.jQuery("#drag-bottom").on("click", function () {
        window.jQuery(".drag-feature").removeClass("active");
        window.jQuery(this).addClass("active"); 
        updateDragMode(2);
    });

    window.jQuery("#drag-disable").on("click", function () {
        window.jQuery(".drag-feature").removeClass("active");
        window.jQuery(this).addClass("active");
        updateDragMode(0);
    });

    window.jQuery("#format-jpeg").on("click", function () {
        window.jQuery(".format-feature").removeClass("active");
        window.jQuery(this).addClass("active");
        updateCaptureFormat("jpeg");
    });

    window.jQuery("#format-png").on("click", function () {
        window.jQuery(".format-feature").removeClass("active");
        window.jQuery(this).addClass("active");
        updateCaptureFormat("png");
    });

    if (isFirefox) {
        window.jQuery("#retina-feature").hide();        
    }

    window.jQuery("#retina-support").on("change", function () {
        setTimeout(function () {
            updateRetinaSupport(window.jQuery("#retina-support")[0].checked);
        }, 100);
    });

    window.jQuery("#collect-support").on("change", function () {
        setTimeout(function () {
            updateCollectWindow(window.jQuery("#collect-support")[0].checked);
        }, 100);
    });

    window.jQuery("#feedback").on("click", function (e) {
        e.preventDefault();
        window.open("mailto:services@eagle.cool");
    });

    window.jQuery("#ranking").on("click", function () {
        window.open("https://chrome.google.com/webstore/detail/eagle/lieogkinebikhdchceieedcigeafdkid/reviews");
    });

    window.jQuery("#shortcuts").on("click", function () {
        chrome.tabs.create({
            url: "chrome://extensions/configureCommands",
            active: true
        });
    });

    window.jQuery("#shortcut-input").on("keydown", function (event) {
        var keyCode = event.keyCode;
        switch (keyCode) {
            case 66:    // B
                window.jQuery("#save-images").trigger("click");
                break;
            case 83:    // B
                window.jQuery("#capture-selected").trigger("click");
                break;
            case 69:    // h
                window.jQuery("#capture-entire").trigger("click");
                break;
        }
    });

    //
    // start doing stuff immediately! - including error cases
    //
    window.jQuery.ajax({
        method:"POST",
        url: "http://localhost:41593",
        dataType: "json",
        data: {},
    }).always(function (result) {
        if (result.status == 0) {
            openEagle();
            window.jQuery("#dropdown-menu").addClass("hide");
        }
        else {
            if (result.appVersion) {
                appVersion = result.appVersion;
                showCollectModal = result.showCollectModal;
            }
            // 带有该属性，表是用户使用的是 1.9.1 build3 版本之后的版本，可以使用新特性
            if (appVersion) {
                $("#collect-feature").show();
                window.jQuery("#collect-support")[0].checked = showCollectModal;
            }
            else {
                $("#collect-feature").hide();
            }

            $("#shortcut-input").focus();
            setTimeout(function () {
                window.jQuery("#not-open-app").addClass("hide");
                window.jQuery("#dropdown-menu").removeClass("hide");
            }, 200);
        }
    })

    function openCropArea () {
        chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
            chrome.tabs.sendMessage(tabs[0].id, { action: "open-crop-area" }, function(response) {});
            setTimeout(function () { window.close(); }, 100);
        });
    };

    function openEagle () {
        chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
            chrome.tabs.sendMessage(tabs[0].id, { action: "open-not-opened-modal" }, function(response) {});
            setTimeout(function () { window.close(); }, 100);
        });
    };
});

chrome.tabs.executeScript(null, { file: "extractSiteMetas.js" });

checkExtensionUpdates();

function checkExtensionUpdates() {

    if (chrome.runtime.id === "lieogkinebikhdchceieedcigeafdkid") return;
    var lastCheckUpdateTime = localStorage.getItem("lastCheckUpdateTime");
    var lastCheckUpdateVersion = localStorage.getItem("lastCheckUpdateVersion");

    var ONE_HOUR = 1000 * 60 * 60;
    var checkURL = "https://eagle.cool/extension/manifest.json";

    if (lastCheckUpdateVersion && lastCheckUpdateTime && Date.now() - lastCheckUpdateTime < ONE_HOUR) {
        var manifest = chrome.runtime.getManifest();
        var version = manifest.version;
        if (lastCheckUpdateVersion && versionSmallThan(version, lastCheckUpdateVersion)) {
            showUpdateNotification(lastCheckUpdateVersion);
        }
        return;
    }

    console.log("檢查扩展是否有更新")
    localStorage.setItem("lastCheckUpdateTime", Date.now());

    var manifest = chrome.runtime.getManifest();
    var version = manifest.version;

    fetch(checkURL)
        .then((response) => response.json()) //assuming file contains json
        .then(function (data) {
            if (data && data.version) {
                localStorage.setItem("lastCheckUpdateVersion", data.version);
                if (versionSmallThan(version, data.version)) {
                    showUpdateNotification(data.version);
                }
            }
        });
}

function versionSmallThan(v1, v2) {
    if (!v1 || !v2) {
        return false;
    }
    var vernums1 = parseInt(v1.replace(/\./g, ""));
    var vernums2 = parseInt(v2.replace(/\./g, ""));
    return vernums1 < vernums2;
};

function showUpdateNotification (version) {
    jQuery("#update-notification").text(i18n_words.dropdown["new-version"] + version);
    jQuery("#update-notification").addClass("show");
    chrome.browserAction.setIcon({ path:"icon128-badge.png" });
}


