var win = window;
function getSiteInfo () {

	var metaTags = ExtractTextTool.extractSiteTags()
	var metaTitle = document.title;
	var metaDescription = jQuery('meta[name="description"]').attr("content");
	var metaKeywords = jQuery('meta[name="keywords"]').attr("content");

	var youtubeID = parseYourubeVideoID(location.href);
	var bilibiliID = parseBiliBiliVideoID(location.href);
	var vimeoID = parseVimeoVideoID(location.href);

	var videoWidth = jQuery("meta[property='og:video:width']").attr("content");
	var videoHeight = jQuery("meta[property='og:video:height']").attr("content");
	var videoThumb;
	var videoID;
	var videoDuration;
	var videoEmbed;

	var videoMedium;
	if (youtubeID) {
		videoID = youtubeID;
		videoMedium = "youtube";
		videoThumb = `https://i.ytimg.com/vi/${youtubeID}/hqdefault.jpg`;
		var duration = jQuery(".ytp-time-duration").text();
		if (duration && hmsToSecondsOnly(duration) > 0) {
			videoDuration = hmsToSecondsOnly(duration);
		}
    }

    if (bilibiliID) {
    	videoID = bilibiliID;
    	videoMedium = "bilibili";
    	videoThumb = jQuery("meta[property='og:image']").attr("content")
    	videoWidth = jQuery("meta[property='og:width']").attr("content");
		videoHeight = jQuery("meta[property='og:height']").attr("content");
		videoEmbed = "https://" +  $(jQuery("#link2").val()).attr("src");
    	var duration = jQuery(".bilibili-player-video-time-total").text();
		if (duration && hmsToSecondsOnly(duration) > 0) {
			videoDuration = hmsToSecondsOnly(duration);
		}
    }

    if (vimeoID) {
    	videoID = vimeoID;
    	videoMedium = "vimeo";
    	videoThumb = jQuery("meta[property='og:image']").attr("content")
    	videoWidth = jQuery("meta[property='og:video:width']").attr("content");
		videoHeight = jQuery("meta[property='og:video:height']").attr("content");
    	var duration = jQuery(".vp-progress [aria-valuemax]").attr("aria-valuemax");
		if (duration && hmsToSecondsOnly(duration) > 0) {
			videoDuration = hmsToSecondsOnly(duration);
		}
    }

    var result = {
    	metaTags: metaTags,
		metaTitle: metaTitle,
		metaDescription: metaDescription,
		metaKeywords: metaKeywords,
		videoID: videoID,
		videoWidth: videoWidth,
		videoHeight: videoHeight,
		videoMedium: videoMedium,
		videoThumb: videoThumb
    };

    if (videoDuration) {
    	result.videoDuration = videoDuration;
    }

    if (videoEmbed) {
    	result.videoEmbed = videoEmbed;
    }

	chrome.runtime.sendMessage({
	    action: "saveURL",
	    result: result
	});

}

function parseYourubeVideoID(url) {
    var regExp = /^.*((youtu.be\/)|(v\/)|(\/u\/\w\/)|(embed\/)|(watch\?))\??v?=?([^#&?]*).*/;
    var match = url.match(regExp);
    return (match && match[7].length == 11) ? match[7] : false;
}

function parseBiliBiliVideoID(url) {
	try {
    	return url.split("bilibili.com/video/")[1].split("?")[0];
    }
    catch (err) {
    	return;
    }
}

function parseVimeoVideoID (url) {
    var m = url.match(/^.+vimeo.com\/(.*\/)?([^#\?]*)/);
    return m ? m[2] || m[1] : null;
}

function hmsToSecondsOnly (str) {
	var p = str.split(':'),
        s = 0, m = 1;

    while (p.length > 0) {
        s += m * parseInt(p.pop(), 10);
        m *= 60;
    }

    return s;
}

getSiteInfo();
